/*******************************************************************************
 * @author    Patricie Benešová
 * @version   1.00.000
 */
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class Zoo {
    private List<Zvire> seznamZviratVZoo = new ArrayList<>();

    public Zoo() {
        seznamZviratVZoo.add(new Zvire("tygr", 4, 4, "savec"));
        seznamZviratVZoo.add(new Zvire("lev", 4, 2, "savec"));
        seznamZviratVZoo.add(new Zvire("vlk", 4, 15, "savec"));
        seznamZviratVZoo.add(new Zvire("bizon", 4, 1, "savec"));
        seznamZviratVZoo.add(new Zvire("had", 0, 2, "plaz"));
        seznamZviratVZoo.add(new Zvire("papoušek", 2, 2, "pták"));
        seznamZviratVZoo.add(new Zvire("velryba", 0, 1, "ryba"));
        seznamZviratVZoo.add(new Zvire("želva", 4, 5, "plaz"));
    }

    /**
     * Getter pro získání seznamu zvířat
     */
    public List<Zvire> getSeznamZviratVZoo() {
        return seznamZviratVZoo;
    }

    public static void main(String[] args) {
        Zoo zoo = new Zoo();
        Map<String, Integer> vysledek = zoo.ziskatPocetKs(zoo.ziskatMapu(zoo.getSeznamZviratVZoo()));
        System.out.println(vysledek);

    }

    /**
     * Pomocná metoda sloužící k získání mapy, jejíž klíčem bude druh zvířete a hodnotou počet
     * zvířat daného druhu.
     */
    public Map<String, Integer> ziskatPocetKs(Map<String, List<Zvire>> mapa) {
        Map<String, Integer> pomocnaMapa = new HashMap<>();
        mapa.forEach((druh, seznam) -> pomocnaMapa.put(druh, seznam.size()));

        return pomocnaMapa;
    }

    /**
     * Pomocná metoda sloužící ke shlukování zvířat dle druhu
     */
    public Map<String, List<Zvire>> ziskatMapu(List<Zvire> seznam) {
        return seznam.stream().collect(Collectors.groupingBy((x) -> x.getDruh()));
    }
}
